package com.emamaker.voxeltest.intervaltrees;

import com.emamaker.voxeltest.intervaltrees.world.WorldManager;
import com.jme3.app.SimpleApplication;
import com.jme3.font.BitmapText;
import com.jme3.renderer.RenderManager;
import com.jme3.util.BufferUtils;

/**
 * This is the Main Class of your Game. It should boot up your game and do initial initialisation
 * Move your Logic into AppStates or Controls or other java classes
 */
public class Voxel extends SimpleApplication {

    WorldManager worldManager = new WorldManager(this);

    public static void main(String[] args) {
        Voxel app = new Voxel();
        app.setShowSettings(false); //Settings dialog not supported on mac
        app.start();
        
        BufferUtils.setTrackDirectMemoryEnabled(true);

    }
    
    @Override
    public void simpleInitApp() {
        getFlyByCamera().setMoveSpeed(20f);
    
        worldManager.initWorld();
        worldManager.render();
    }
    
    @Override
    public void simpleUpdate(float tpf) {
        // System.out.println(this.getCamera().getLocation());
    }

    @Override
    public void simpleRender(RenderManager rm) {
        //add render code here (if any)
    }
}
