package com.emamaker.voxeltest.intervaltrees.data;

/* When visualizing as a 1D array, high indicates the last index with a valid position (es. if there are 10 values), the interval will be (0,9) */

public class Interval {
    int low, high;

    public Interval() {
        set(0, 0);
    }

    
    public Interval(int low_, int high_) {
        set(low_, high_);
    }
    
    public void set(int low_, int high_) {
        this.low = low_;
        this.high = high_;
    }
    
    public int getLow(){
        return low;
    }

    public int getHigh(){
        return high;
    }
    public boolean isValid() {
        return this.low < this.high;
    }

    // return if is contained in another interval
    public boolean contains(Interval i) {
        return this.low <= i.low && i.high <= this.high;
    }

    // if contains another interval
    public boolean isContainedBy(Interval i) {
        return i.contains(this);
    }

    public boolean fullyLeftOf(Interval i) {
        return this.high < i.low;
    }

    public boolean fullyRightOf(Interval i) {
        return this.low > i.high;
    }

    public boolean partiallyContainsLeft(Interval i) {
        return i.low < this.low && i.high >= this.low && i.high < this.high;
    }

    public boolean partiallyContainsRight(Interval i) {
        return this.high >= i.low && this.low < i.low && this.high < i.high;
    }

    @Override
    public String toString() {
        return "[" + low + ", " + high + "]";
    }
}