package com.emamaker.voxeltest.intervaltrees.world;

import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Queue;

import com.emamaker.voxeltest.intervaltrees.Voxel;
import com.emamaker.voxeltest.intervaltrees.renderer.ChunkRenderer;
import com.jme3.math.Vector3f;

public class WorldManager {

    public    final Voxel game;

    ChunkRenderer chunkRenderer = new ChunkRenderer();

    HashMap<Vector3f, Chunk> chunks = new HashMap<>();
    Queue<Chunk> chunkToModel = new ArrayDeque();
    ArrayList<Chunk> chunksToRender = new ArrayList<>();

    public WorldManager(final Voxel game_) {
        this.game = game_;
    }

    public void initWorld() {
        chunks.put(Vector3f.ZERO, new Chunk());
        chunks.get(Vector3f.ZERO).generateStair();

        chunkToModel.add(chunks.get(Vector3f.ZERO));
    }

    public void render() {
        for (Chunk c : chunkToModel) {
            // chunkRenderer.stupidArrayMeshing(this, c);
            chunkRenderer.greedyMeshing(this, c);
            
            game.getRootNode().attachChild(c.chunkNode);
        }
    }

}
